# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ResolvedServiceEndpoint(Model):
    """Endpoint of a resolved service partition.

    :param kind: The role of the replica where the endpoint is reported.
     Possible values include: 'Invalid', 'Stateless', 'StatefulPrimary',
     'StatefulSecondary'
    :type kind: str or ~azure.servicefabric.models.ServiceEndpointRole
    :param address: The address of the endpoint. If the endpoint has multiple
     listeners the address is a JSON object with one property per listener with
     the value as the address of that listener.
    :type address: str
    """

    _attribute_map = {
        'kind': {'key': 'Kind', 'type': 'str'},
        'address': {'key': 'Address', 'type': 'str'},
    }

    def __init__(self, *, kind=None, address: str=None, **kwargs) -> None:
        super(ResolvedServiceEndpoint, self).__init__(**kwargs)
        self.kind = kind
        self.address = address
